QCA::ConstraintType Class Reference
QCA user API

`#include <QtCrypto>`

## Public Types

enum | Section { KeyUsage , ExtendedKeyUsage }

## Public Member Functions

| ConstraintType ()
| ConstraintType (const ConstraintType &from)
| ConstraintType (const QString &id, Section section)
| ConstraintType (ConstraintTypeKnown known)
QString | id () const
ConstraintTypeKnown | known () const
bool | operator!= (const ConstraintType &other) const
bool | operator< (const ConstraintType &other) const
ConstraintType & | operator= (const ConstraintType &from)
bool | operator== (const ConstraintType &other) const
Section | section () const

## Detailed Description

Certificate constraint.

X.509 certificates can be constrained in their application - that is, some certificates can only be used for certain purposes. This class is used to identify an approved purpose for a certificate.

Note
  It is common for a certificate to have more than one purpose.

## Member Enumeration Documentation

## Section

enum QCA::ConstraintType::Section

Section of the certificate that the constraint belongs in.

Enumerator
KeyUsage | Stored in the key usage section.
ExtendedKeyUsage | Stored in the extended key usage section.

## Constructor & Destructor Documentation

## ConstraintType() [1/4]

QCA::ConstraintType::ConstraintType | ( |  | ) |

Standard constructor.

Referenced by ConstraintType(), operator!=(), operator<(), operator=(), and operator==().

## ConstraintType() [2/4]

QCA::ConstraintType::ConstraintType | ( | ConstraintTypeKnown | known | ) |

Construct a new constraint.

The section will be derived by known.

Parameters

  known | the type as part of the ConstraintTypeKnown enumerator

References known().

## ConstraintType() [3/4]

QCA::ConstraintType::ConstraintType | ( | const QString & | id,
|  | Section | section )

Construct a new constraint.

Parameters

  id | the type as an identifier string (OID or internal)
  section | the section this type belongs in

See also
  id

References section().

## ConstraintType() [4/4]

QCA::ConstraintType::ConstraintType | ( | const ConstraintType & | from | ) |

Standard copy constructor.

Parameters

  from | the constraint type to copy from

References ConstraintType().

## Member Function Documentation

## operator=()

ConstraintType & QCA::ConstraintType::operator= | ( | const ConstraintType & | from | ) |

Standard assignment operator.

Parameters

  from | the constraint type to assign from

References ConstraintType().

## section()

Section QCA::ConstraintType::section | ( |  | ) | const

The section the constraint is part of.

Referenced by ConstraintType().

## known()

ConstraintTypeKnown QCA::ConstraintType::known | ( |  | ) | const

The type as part of the ConstraintTypeKnown enumerator.

This function may return a value that does not exist in the enumerator. In that case, you may use id() to determine the type.

Referenced by ConstraintType().

## id()

QString QCA::ConstraintType::id | ( |  | ) | const

The type as an identifier string.

For types that have OIDs, this function returns an OID in string form. For types that do not have OIDs, this function returns an internal identifier string whose first character is not a digit (this allows you to tell the difference between an OID and an internal identifier).

It is hereby stated that the KeyUsage bit fields shall use the internal identifier format "KeyUsage.[rfc field name]". For example, the keyEncipherment field would have the identifier "KeyUsage.keyEncipherment".

Applications should not store, use, or compare against internal identifiers unless the identifiers are explicitly documented (e.g. KeyUsage).

## operator<()

bool QCA::ConstraintType::operator< | ( | const ConstraintType & | other | ) | const

Comparison operator.

Parameters

  other | the constraint type to compare with this constraint

References ConstraintType().

## operator==()

bool QCA::ConstraintType::operator== | ( | const ConstraintType & | other | ) | const

Comparison operator.

Parameters

  other | the constraint type to compare with this constraint

References ConstraintType().

## operator!=()

bool QCA::ConstraintType::operator!= | ( | const ConstraintType & | other | ) | const

inline

Inequality operator.

Parameters

  other | the constraint type to compare with this constraint

References ConstraintType().

The documentation for this class was generated from the following file:

- qca_cert.h